> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/get-started/samples/showcase-demo-color-separation.md).

# Color Separation Showcase Demo Code Sample

Manipulate colors in PDF documents, view or hide — all on the client side.

{% hint style="info" %}
**Requirements**

*These packages are required to use these features in production. Trial keys have unlimited access to all features*

<a href="/web/get-started/readme.md" class="button primary">Web SDK</a><a href="https://showcase.apryse.com/color-separation" class="button primary">Live demo</a>
{% endhint %}

Easily manipulate colors in PDF documents — all on the client side.

This demo lets you:

* Process CMYK colors.
* Upload your own PDF.
* Show, hide, and isolate colors with ease.

**Implementation steps** To add Color Separation capability with WebViewer:

Step 1: [Get started with WebViewer](/web/get-started/readme.md) in your preferred web stack. Step 2: Add the ES6 JavaScript sample code provided in this guide.

Once you generate your license key, it will automatically be included in your sample code below.

{% @apryse-license-key/apryse-license-key platform="WEB\_VIEWER" variant="compact" %}

{% tabs %}
{% tab title="index.js" %}

<pre class="language-js" data-line-numbers><code class="lang-js">// ES6 Compliant Syntax
// GitHub Copilot v1.0, Claude Sonnet 4, October 15, 2025
// File: index.js

import WebViewer from '@pdftron/webviewer';

const licenseKey = '<code class="expression">visitor.claims.wvKey || "YOUR_WEBVIEWER_LICENSE_KEY"</code>';

// CMYK Color Separation Demo
// This code demonstrates how to show, hide and separate colors in PDF with no external dependencies or servers required.

// Global variable to store the reset loading handler for proper cleanup
let resetLoadingHandler = null;

function initializeWebViewer() {

    // This code initializes the WebViewer with the basic settings
    WebViewer({
        path: '/lib',
        licenseKey: licenseKey,
        enableFilePicker: true,
        loadAsPDF: true, // Ensure files are loaded as PDF documents for best color separation support
    }, document.getElementById('viewer')).then((instance) => {
        // Enable the measurement toolbar so it appears with all the other tools, and disable Cloudy rectangular tool
        const cloudyTools = [
            instance.Core.Tools.ToolNames.CLOUDY_RECTANGULAR_AREA_MEASUREMENT,
            instance.Core.Tools.ToolNames.CLOUDY_RECTANGULAR_AREA_MEASUREMENT2,
            instance.Core.Tools.ToolNames.CLOUDY_RECTANGULAR_AREA_MEASUREMENT3,
            instance.Core.Tools.ToolNames.CLOUDY_RECTANGULAR_AREA_MEASUREMENT4,
        ];
        instance.UI.enableFeatures([instance.UI.Feature.Measurement, instance.UI.Feature.Initials]);
        instance.UI.disableTools(cloudyTools);
        // Set default toolbar group to Annotate
        instance.UI.setToolbarGroup('toolbarGroup-Annotate');
        // Set default tool on mobile devices to Pan.
        if (UIElements.isMobileDevice()) {
            instance.UI.setToolMode(instance.Core.Tools.ToolNames.PAN);
        }

        instance.Core.documentViewer.addEventListener('documentUnloaded', () => {
            if (searchParams.has('file')) {
                searchParams.delete('file');
                history.replaceState(null, '', '?' + searchParams.toString());
            }
        });

        instance.Core.annotationManager.enableAnnotationNumbering();
        instance.UI.NotesPanel.enableAttachmentPreview();
        // Add the demo-specific functionality
        customizeUI(instance).then(() => {
            // Create UI controls after demo is initialized
            UIElements.createUIControls();
        });
    });
}

let colorValues = [];
let loadingColors = [];
const searchParams = new URLSearchParams(window.location.search);
const history = window.history || window.parent.history || window.top.history;

const customizeUI = async (instance) => {
    // Load the default document
    await instance.UI.loadDocument('https://apryse.s3.us-west-1.amazonaws.com/public/files/samples/op_blend_test.pdf');
    // Set allowed file types to load
    const allowedFileTypes = [
        'pdf', // PDF
        'jpg', 'jpeg', 'png', // Images        
        'doc', 'docx', 'docm', 'dotx', 'dotm', 'dot', 'xls', 'xlsx', 'xlsm', 'xlt', 'xls', 'odt', 'txt', 'rtf', 'pptx', 'ppt', 'pptm', 'pps', 'pot' // MS Office
    ];
    instance.Core.setAllowedFileExtensions(allowedFileTypes);
    await initColorSeparation(instance); // Initialize color separation
};

const initColorSeparation = async (instance) => {
    const { documentViewer } = instance.Core;
    documentViewer.addEventListener('documentLoaded', async () => {
        // Clear checkbox container from all previous color separations
        const checkboxContainer = document.querySelector('.checkbox-container');
        if (checkboxContainer) {
            checkboxContainer.innerHTML = '';
        }
        // Get the document object
        const doc = documentViewer.getDocument();
        // Enable color separations on the document
        doc.enableColorSeparations();
        // Event listener for when a new color separation is added
        doc.addEventListener('colorSeparationAdded', (colorData) => {
            // Add a new checkbox for the added color separation
            const checkboxContainer = document.querySelector('.checkbox-container');
            if (checkboxContainer) {
                // Create a wrapper for the checkbox
                const checkboxWrapper = document.createElement('div');
                checkboxWrapper.className = 'checkbox-wrapper';
                // Add a checkbox for the new color separation
                const checkbox = document.createElement('input');
                checkbox.type = 'checkbox';
                checkbox.id = `color-checkbox-${colorData.name}`;
                checkbox.name = 'colorSeparation';
                checkbox.value = colorData.name;
                checkbox.checked = colorData.enabled;
                checkbox.onchange = (e) => {
                    toggleColor(instance, colorData, e.target.checked);
                }
                checkbox.style.display = 'none'; // Hide the default checkbox
                // Custom checkbox
                const span = document.createElement('span');
                span.className = 'checkbox-checkmark';
                span.id = `checkmark-${colorData.name}`;
                if (checkbox.checked) {
                    span.textContent = '✓'; // U+2713
                }
                span.onclick = () => {
                    checkbox.checked = !checkbox.checked;
                    checkbox.onchange({ target: checkbox });
                    span.textContent = checkbox.checked ? '✓' : ''; // U+2713
                }
                span.style.backgroundColor = rgbToString(colorData.rgb);
                span.style.border = `3px solid ${rgbToString(colorData.rgb)}`;
                // Label for the checkbox
                const label = document.createElement('label');
                label.className = 'label';
                label.textContent = colorData.name;
                label.onclick = () => {
                    checkbox.checked = !checkbox.checked;
                    checkbox.onchange({ target: checkbox });
                    span.textContent = checkbox.checked ? '✓' : ''; // U+2713
                }
                // Percentage text
                const percentage = document.createElement('span');
                percentage.id = `percentage-${colorData.name}`;
                percentage.className = 'label';
                percentage.textContent = `0%`;
                // Append elements to the wrapper and then to the container
                checkboxWrapper.appendChild(checkbox);
                checkboxWrapper.appendChild(span);
                checkboxWrapper.appendChild(label);
                checkboxWrapper.appendChild(percentage);
                checkboxContainer.appendChild(checkboxWrapper);
            }
        });
    });

    // Helper function to convert RGB array to CSS rgb() string
    const rgbToString = (rgb) => {
        const [r, g, b] = rgb;
        return `rgb(${r}, ${g}, ${b})`;
    };

    // Function to toggle color separation
    const toggleColor = (instance, color, checked) => {
        const documentViewer = instance.Core.documentViewer;
        loadingColors = [...loadingColors, color.name];
        console.log(`Toggling color separation for ${color.name}:`, checked);
        
        // Create handler if it doesn't exist
        if (!resetLoadingHandler) {
            resetLoadingHandler = () => resetLoading(instance);
        }
        
        documentViewer.addEventListener('pageComplete', resetLoadingHandler);
        documentViewer.getDocument().enableSeparation(color.name, checked);
        documentViewer.refreshAll();
        documentViewer.updateView();
    };

    // Function to update color values on mouse move
    documentViewer.addEventListener('mouseMove', (event) => {
        const mouseLocation = documentViewer.getToolMode().getMouseLocation(event);
        const displayMode = documentViewer.getDisplayModeManager().getDisplayMode();
        const pageNumber = displayMode.getSelectedPages(mouseLocation, mouseLocation).first;
        if (pageNumber !== null) {
            const pageCoordinate = displayMode.windowToPage(mouseLocation, pageNumber);
            if (pageCoordinate) {
                const results = documentViewer.getColorSeparationsAtPoint(pageNumber, pageCoordinate.x, pageCoordinate.y);
                colorValues = results.reduce(function (map, obj) {
                    map[obj.name] = obj.value;
                    return map;
                }, {});
            }
        }
        // Update percentage text for each color
        const percentageElements = document.querySelectorAll('.label[id^="percentage-"]');
        percentageElements.forEach((el) => {
            const colorName = el.id.replace('percentage-', '');
            if (colorValues &#x26;&#x26; colorValues[colorName] !== undefined) {
                el.textContent = `${colorValues[colorName]}%`;
            } else {
                el.textContent = `0%`;
            }
        });
    });
};

// Function to reset which separations are loaded in order to disable/enable specific separations
const resetLoading = (instance) => {
    loadingColors = [];
    instance.Core.documentViewer.removeEventListener('pageComplete', resetLoadingHandler);
};

// Cleanup function for when the demo is closed or page is unloaded
const cleanup = (instance) => {
    if (typeof instance !== 'undefined' &#x26;&#x26; instance.UI) {
        if (instance.Core.documentViewer.getDocument()) {
            instance.Core.documentViewer
                .getDocument()
                .removeEventListener('colorSeparationAdded', setColorData);
            instance.Core.documentViewer.removeEventListener('pageComplete', resetLoadingHandler);
            instance.Core.documentViewer.removeEventListener('mouseMove', updateMouseMove);
        }
        console.log('Cleaning up color-separation demo');
    }
};

// Register cleanup for page unload
window.addEventListener('beforeunload', () => cleanup(instance));
window.addEventListener('unload', () => cleanup(instance));

// Helper function to load the ui-elements.js script
function loadUIElementsScript() {
    return new Promise((resolve, reject) => {
        if (window.UIElements) {
            console.log('UIElements already loaded');
            resolve();
            return;
        }
        const script = document.createElement('script');
        script.src = '/showcase-demos/color-separation/ui-elements.js';
        script.onload = function () {
            console.log('✅ UIElements script loaded successfully');
            resolve();
        };
        script.onerror = function () {
            console.error('Failed to load UIElements script');
            reject(new Error('Failed to load ui-elements.js'));
        };
        document.head.appendChild(script);
    });
}

// Load UIElements script first, then initialize WebViewer
loadUIElementsScript().then(() => {
    initializeWebViewer();
}).catch((error) => {
    console.error('Failed to load UIElements:', error);
});

</code></pre>

{% endtab %}

{% tab title="ui-elements.js" %}
{% code title="ui-elements.js" lineNumbers="true" %}

```js
// ES6 Compliant Syntax
// GitHub Copilot v1.0, Claude Sonnet 4, October 15, 2025
// File: ui-elements.js

// UI Elements class to create and manage custom UI controls
//
// Helper code to add controls to the viewer holding the buttons
// This code creates a container for the buttons, styles them, and adds them to the viewer
//
class UIElements {
    // Function to check if the user is on a mobile device
    static isMobileDevice = () => {
        return (
            /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(
                window.navigator.userAgent
            ) ||
            /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw-(n|u)|c55\/|capi|ccwa|cdm-|cell|chtm|cldc|cmd-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc-s|devi|dica|dmob|do(c|p)o|ds(12|-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(-|_)|g1 u|g560|gene|gf-5|g-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd-(m|p|t)|hei-|hi(pt|ta)|hp( i|ip)|hs-c|ht(c(-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i-(20|go|ma)|i230|iac( |-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|-[a-w])|libw|lynx|m1-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|-([1-8]|c))|phil|pire|pl(ay|uc)|pn-2|po(ck|rt|se)|prox|psio|pt-g|qa-a|qc(07|12|21|32|60|-[2-7]|i-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h-|oo|p-)|sdk\/|se(c(-|0|1)|47|mc|nd|ri)|sgh-|shar|sie(-|m)|sk-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h-|v-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl-|tdg-|tel(i|m)|tim-|t-mo|to(pl|sh)|ts(70|m-|m3|m5)|tx-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas-|your|zeto|zte-/i.test(
                window.navigator.userAgent.substring(0, 4)
            )
        );
    }

    static checkboxes = () => {
        // Create a container for the checkboxes
        const container = document.createElement('div');
        container.className = 'checkbox-container';
        return container;
    }

    static createUIControls = () => {
        // Create a container for all controls
        const controlsContainer = document.createElement('div');
        controlsContainer.className = 'controls-container';

        // Create and append the colors checkbox control
        controlsContainer.appendChild(this.checkboxes());

        // Add the controls container to the viewer element
        const element = document.getElementById('viewer');
        element.insertBefore(controlsContainer, element.firstChild);

        console.log('✅ UI controls created');
    };
}
```

{% endcode %}
{% endtab %}

{% tab title="index.css" %}
{% code title="index.css" lineNumbers="true" %}

```css
/* CSS standard Compliant Syntax */
/* GitHub Copilot v1.0, Claude Sonnet 4, October 15, 2025 */
/* File: index.css */

/* Controls Container */
.controls-container {
    display: flex;
    flex-direction: row;
    align-items: center;
    gap: 15px;
    margin: 5px 0;
    padding: 16px;
    padding-bottom: 5px;
    border-bottom: 1px solid #DFE1E6;
    background-color: rgba(112, 198, 255, 0.2);
}

.checkbox-container {
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    margin: 10px 0;
    gap: 10px;
}

.checkbox-wrapper {
    display: flex;
    flex-direction: column;
    align-items: center;
    margin-right: 10px;
}

.label {
    font-size: 14px;
    line-height: 20px;
    color: #485056;
    letter-spacing: -0.3px;
    margin-right: 5px;
    font-weight: 700;
    cursor: pointer;
}

.checkbox-checkmark {
    border-radius: 6px;
    width: 24px;
    height: 24px;
    margin: 3px;
    cursor: pointer;
    text-align: center;
    line-height: 18px;
    display: inline-block;
    color: #FFFFFF;
    /* The following will be set dynamically in JS:
     background-color, border */
}
```

{% endcode %}
{% endtab %}
{% endtabs %}

[View the full sample on GitHub](https://github.com/ApryseSDK/webviewer-samples/tree/main/showcase-demos-playground)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/get-started/samples/showcase-demo-color-separation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
